/*
 * Anschluss einer LDC-Anzeige des Typs DOGM162L-A  "Display On Glas"
 * 2 Textzeilen je 16 Zeichen
 * Datenblatt: "http://www.lcd-module.de/pdf/doma/dog-m.pdf"
 * copyleft DL9MWE, 22.05.2014 *** "by-nd"
 */

#include "main.h"

void main(void) {
	vCPU_init();

#if 0
// Test der delay-Routinen
	int ii;
	P1DIR = LEDrotBIT;		//konfiguriere Pin an Port 1 fr LED-Ansteuerung als Ausgang
	P1OUT |= LEDrotBIT;		//setze Portbit auf 1 -> LED An

	_delay_ms(10000);		// 10000*1ms = 10sek
	P1OUT &= ~LEDrotBIT;	//setze Portbit auf 0 -> LED Aus

	P1OUT |= LEDrotBIT;		//setze Portbit auf 1 -> LED An
	for(ii=0;ii<100;++ii) {	// 100*10000*10us = 10sek
		_delay_10us(10000);
	}
	P1OUT &= ~LEDrotBIT;	//setze Portbit auf 0 -> LED Aus
#endif

	while(42) {
		vLCD_init();		// Initialisierung des Displays; Cursor Home, Cursor off

		// Test.................
		vLCD_puts("Hallo Welt");
		_delay_ms(1000);	// 1 Sekunde warten
		vLCD_gotoxy(1,2);	// erstes Zeichen in Zeile 2
		vLCD_putc('#');
		_delay_ms(1410);	// 1,41 Sekunde warten
		vLCD_putui(813);
		_delay_ms(1000);	// 1 Sekunde warten
		vLCD_putc('\xB8');	// 1011 1000 siehe Datenblatt
		_delay_ms(1000);	// 1 Sekunde warten
		vLCD_puti(813);
		_delay_ms(1500);	// 1,5 Sekunde warten
		vLCD_gotoxy(6,1);	// 6. Zeichen in Zeile 1
		vLCD_putc('-');

		_delay_ms(2500);	// 2,5 Sekunden warten
		vLCD_clear();
		//vLCD_gotoxy(1,1);	unntig: nach vLCD_clear ist der Cursor bereits bei 1,1
		vLCD_puts("Test  Cursorpos.");
		_delay_ms(1000);	// 1 Sekunde warten
		vLCD_gotoxy(2,2);
		vLCD_putui(1);
		vLCD_gotoxy(2,2);
		_delay_ms(707);		// 0,707 Sekunde warten
		vLCD_putui(10);
		vLCD_gotoxy(3,2);
		_delay_ms(707);		// 0,707 Sekunde warten
		vLCD_putui(1000);
		vLCD_gotoxy(4,2);
		_delay_ms(707);		// 0,707 Sekunde warten
		vLCD_putui(10000);

		_delay_ms(3000);	// 3 Sekunden warten
		vLCD_clear();
		vLCD_puts("signed int");
		vLCD_gotoxy(2,2);	// min
		vLCD_puti(-32768);
		vLCD_gotoxy(11,2);
		vLCD_puti(32767);	// max

		_delay_ms(3000);	// 3 Sekunden warten
		vLCD_clear();
		vLCD_puts("unsigned int");
		vLCD_gotoxy(2,2);
		vLCD_putui(0);		// min
		vLCD_gotoxy(11,2);
		vLCD_putui(65535);	// max

		_delay_ms(3000);	// 3 Sekunden warten
		vLCD_clear();
		vLCD_gotoxy(6,1);
		vLCD_puts("DL9MWE");
		vLCD_gotoxy(4,2);
		vLCD_puts("22.05.2014");

		_delay_ms(7070);		// 7,07 Sekunden warten, dann alles von vorne
	}
}


void vCPU_init(void) {
	WDTCTL = WDTPW + WDTHOLD;	// stop watchdog-timer

	DCOCTL = CALDCO_1MHZ;		// interner Oszillator @ 1Mhz
	BCSCTL1 = CALBC1_1MHZ;
	BCSCTL2 = 0;
	BCSCTL3 = 0;
}

// usec * 10 Mikrosekunden warten
void _delay_10us(unsigned int usec) {
	volatile int count;
	count = usec;
	while(count) {
		--count;
	}
}

// msec Millisekunden warten
void _delay_ms(unsigned int msec) {
  volatile unsigned int count;

	while(--msec) {
		count = 100;	// passt bei 1MHz aus dem internen Oszillator DCO
		while(count) {
			--count;
		}
	}
}

// Ende main.c
